# OTB provider for QGIS Processing


## Installation using QGIS plugin manager

Please refer to manual installation. This plugin will be moved to qgis processing core after intial testing.


## Manual Installation


Clone qgis-otb-plugin repository and set QGIS_PLUGINPATH. 

### For Linux/Unix/MacOSX
```
mkdir $HOME/projects; cd $HOME/projects
git clone https://gitlab.orfeo-toolbox.org/orfeotoolbox/qgis-otb-plugin
export QGIS_PLUGINPATH=$HOME/projects/qgis-otb-plugin
```
### For Windows
Clone qgis-otb-plugin repository to `c:\qgis-plugins\qgis-otb-plugin`

`git clone https://gitlab.orfeo-toolbox.org/orfeotoolbox/qgis-otb-plugin`

#### Set `QGIS_PLUGINPATH`
* System properties (`Windows Key + R -> sysdm.cpl` ) 
* Select Advanced Tab -> Environment variables. 
* Under "user variables for " 
* Add or Edit variable `QGIS_PLUGINPATH` and set value to `C:\qgis-plugins\qgis-otb-plugin`

### Download and Install OTB

OTB is not distributed with qgis-otb-plugin. It is a seperate project and has its own git repository.

Download OTB: https://www.orfeo-toolbox.org/download/

Git repository: https://gitlab.orfeo-toolbox.org/orfeotoolbox/otb

### Configure plugin in QGIS

#### Start QGIS

If you already have QGIS opened, you must restart it.

#### Install otb plugin

`Plugins -> Manage and Install Plugins `

Click on `Installed` tab on left and make sure box next to `OrfeoToolBox(OTB)` is checked.

#### Open processing settings
  
`Settings -> Options -> Processing (left panel)`

You can see OTB under "Providers".

* Expand OTB tab
* Tick Activate option
* Set OTB folder. This is location of your OTB installation.
* Set OTB application folder. This is location of your OTB applications. `<OTB_FOLDER>/lib/otb/applications`
* Click "ok" to save settings and close dialog. If settings are correct, you will have OTB algorithms loaded  in Processing toolbox

Installation finished!
------

#### OTB settings available in QGIS Processing

##### Activate
This is a checkbox to activate or deactivate OTB provider. Any invalid settings in OTB folder will uncheck this when saved.

##### OTB folder
This is the directory where OTB is available. Valid values are list below.
* OTB build folder (for source builds), 
* Folder in which OTB is installed using `make install`, package managers or official binary packages

##### OTB application folder
This is the location(s) of OTB applications.

Multiple paths are allowed to use custom/proprietary OTB applications.

##### Geoid file (optional)
Path to geoid file. 

Value of this options is set for `elev.dem.geoid` and `elev.geoid` parameters in OTB applications.

Setting this value globally help users to share it across multiple processing algorithms. 

This value is empty by default.


##### SRTM tiles folder (optional)
Directory where SRTM tiles are available.

SRTM data can be stored locally to avoid connecting to downloading of files during processing.

Value of this options is set for `elev.dem.path` and `elev.dem` parameters in OTB applications.

Setting this value globally help users to share it across multiple processing algorithms.

This value is empty by default.

See OTB issue for a related feature request in OTB QtWidget wrapper. https://gitlab.orfeo-toolbox.org/orfeotoolbox/otb/issues/1560

##### Version
* QGIS : 3.0.2 or later
* OTB  : 6.6.0 or later



